/*
	Display Property
	
	display: block;
		- changes the element into a block element
		- makes element take up full width of browser
		ex.: p, h1-h6, div, ul/ol + li


	display: inline;
		- changes element into an inline element
		- element takes up only the space needed
		ex.: span, button, label, input

	display: inline-block;
		- a combination of inline and block
		- acts as an inline element, but still has block properties (height and width are adjustable)
		ex.: img

	display: none;
		- hides the element from the website; will not show the element
		- 

*/

#div-1{
	background-color: green;
	display: inline;
	width: 200px;
	height: 200px;
}

#span-1{
	background-color: purple;
	display: none;
	width: 200px;
	height: 200px;
}

#span-2{
	background-color: red;
	display: block;
}

#div-2{
	background-color: hotpink;
	display: none;
}

#img{
	width: 250px;
	height: 250px;
	display: inline-block;
}

/*
	CSS Background Property (Color Values)
	#hexcode value
		- hexadecimal color is specified with:
			- #RRGGBB (red, green, blue)
			- Uses numbers between 00 and FF ((darker) 0-9, A-F (whiter))

	rgb (r g b) or rgba (a stands for alpha value)
		- values inside the parenthesis equal to anywhere between 0 to 255 (0% to 100%)
		- alpha value sets the opacity of a color set (0.0 to 1.0)

	color name values
		- composed of 140 colors, commonly used for changing color of element

*/

#p-1{
	background-color: #87CEFA; /*hexcode value*/
}

#p-2{
	background-color: rgba(255, 105, 180, 0.50); /* rgb() or rgba()*/
	width: 60%;
}

#p-3{
	background-color: yellow;
	width: 40%;
}

.sample{
	display: inline-block;
	width: 30%;
	/*border: thickness, border_type (solid, dashed, etc), color*/
	border: 1px solid black;
	text-align: center;
}

/*
	CSS Float Property

		- none: element will not float
		- right: floats to the right of its container
		- left: floats to the left of its container
		- inherit: inherits float values of parent

*/

.img-float{
	height: 250px;
	width: 250px;
	float: inherit;
}

/*
	CSS Units
	
	pixels (px)
		- relative to the viewscreen; based on screen resolution
		- a screen w/ higher resolution will contain more pixels

	percentage (%)
		- relative to parent element
		- height and width will be based on the parent container (ex. 50% of <body>'s size)

		viewport units (vh - height; vw - width)
		- relative to viewport/browser window size (aka based on the device used to view)
		- measures from "corner to corner"

		em
		- relative to parent element
		- equal pix size = em * parent set size

		rem
		- relative to root element (HTML tag)
		- equal px size = rem * root size

*/

.box{
	background-color: red;
	border: 1px solid black;
	margin: 5px;
	padding: 5px;
}

.fifty-percent{
	width: 50%;
}

.one-hundred-pixels{
	width: 100px;
}

.parent{
	width: 250px;
	border: 2px solid navy;
	font-size: 30px;
}

.fifty-vw{
	width: 50vw;
}

.twenty-five-vh{
	height: 25vh;
}

.one-rem{
	/*1rem	= 16px (font-size of the root element)*/
	font-size: 1rem;
}

.one-em{
	font-size: 1em;
}

.two-rem{
	font-size: 2rem;
}

.two-em{
	font-size: 2em;
}

.two-hundred-percent{
	font-size: 200%;
}

/*

	Background Property
	- background-color: changes bg color
	- background-image: url(URI) - takes on the path of the image
		- background-repeat: sets how the background image will be repeated
			- no-repeat
			- repeat
			- repeat-x
			- repeat-y
			- space (allows spaces in between repetition)
			- round (centers image)
		- background-size: specify the size of the background image
			- auto (based on img size)
			- cover (stretches out)
			- contain (fits given space)
			- unit values (10%, 100px, etc)
		- background-position: changes position of bg image relative to HTML element; need to change x and y axis
			- top center bottom (y-axis) and left center right (x-axis) 
			- unit values (0-100; l-r, t-b)
		- background-attachment: sets whether a background image scrolls with rest of page or is fixed

*/
.background{
	min-height: 20rem;
/*	background-color: gray;*/
	/*hex value is #808080; rgb(128, 128, 128)*/
	background-image: url(https://c4.wallpaperflare.com/wallpaper/43/1003/707/anime-your-name-kimi-no-na-wa-mitsuha-miyamizu-wallpaper-preview.jpg);
	background-repeat: no-repeat;
	background-size: 100%;
	/*background-position:	x-axis, y-axis*/
	background-position: 40% 10%;
	background-attachment: fixed;
}

.bg-title{
	color: white;
	text-align: center;
	font-size: 5em;
	margin: 0;
	line-height: 35rem;
}

.container-bg{
	background-color: rgba(0, 0, 0, 0.5);
	min-height: 100vh;
}

/*
	CSS Position Property

	position: static:
		- default value for elements; follows document flow
		- Left, right, top, bottom, Z-index won't apply w/ static position
	
	position: relative
		- remains with normal document flow, but will be affected by the Top, Left, Right, Bottom, and Z-index property.

	position: absolute
		- positioned relative to their closest positioned ancestor (w/o any other positioned element, it will follow HTML)
	
	position: fixed
		- similar w/ absolute position, but it always positions element relative to the initial containing block (HTML tag)

	position: sticky
		- acts relatively positioned element until a scroll point is passed, then it acts like a fixed element

*/

.parent-element {
    background-color: skyblue;
    padding: 50px 10px;
    position: relative;
    height: 800vh;
}


.child-one {
    background-color: gray;
    padding: 10px;
}

.child-two {
    background-color: yellow;
    padding: 10px;
    position: sticky;
    top: 0;
}

.child-three {
    background-color: gray;
    padding: 10px;
}
/*
	
	Z-Index property
		- Also belongs to position (top, bottom, left, right)
		- Manipulates order of stacked elements
		- An element with greater stack order is always in front of an element with a lower stack order.

*/

.container{
	position: relative;
}

.black-box{
	position: relative;
	z-index: 1;
	border: 2px solid black;
	height: 100px;
	margin: 30px;
}

.gray-box{
	position: absolute;
	z-index: 3;
	background-color: lightgray;
	height: 60px;
	width: 70%;
	left: 50px;
	top: 50px;
}

.green-box{
	position: absolute;
	z-index: 2;
	background-color: lightgreen;
	width: 35%;
	left: 270px;
	top: -15px;
	height: 100px;
}